"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThemeProvider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable no-irregular-whitespace */
var react_1 = require("react");
var CssBaseline_1 = __importDefault(require("@material-ui/core/CssBaseline"));
var createTheme_1 = require("./createTheme");
var styles_1 = require("@material-ui/core/styles");
var useIsDarkModeEnabled_1 = require("./useIsDarkModeEnabled");
function ThemeProvider(props) {
    var children = props.children;
    var isDarkModeEnabled = useIsDarkModeEnabled_1.useIsDarkModeEnabled().isDarkModeEnabled;
    var theme = react_1.useMemo(function () { return createTheme_1.createTheme({ isDarkModeEnabled: isDarkModeEnabled }); }, [isDarkModeEnabled]).theme;
    return (jsx_runtime_1.jsxs(styles_1.ThemeProvider, __assign({ theme: theme }, { children: [jsx_runtime_1.jsx(CssBaseline_1.default, {}, void 0),
            jsx_runtime_1.jsx(styles_1.StylesProvider, __assign({ injectFirst: true }, { children: children }), void 0)] }), void 0));
}
exports.ThemeProvider = ThemeProvider;
//# sourceMappingURL=ThemeProvider.js.map